<html>
	<head>
		<title>Transept de la cathédrale d'Amiens</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
	</head>

	<body>
		<script src="../Libs/three.min.js"></script>
		<script src="../Libs/OBJLoader.js"></script>

		<script>
			var container; 
            
			var camera, scene, renderer;
			var dax=0.002;

			var moveSpeed = 0.15;
			var rotateSpeed = 0.1;

			var northBorder = 10;	// Arbitrary choice
			var westBorder = 4.5;	// Arbitrary choice
			var heightBorder = 20.7;
			
			var torch = new THREE.PointLight(0xff7f00,6,5,2);
			var ambient = new THREE.AmbientLight( 0x330000 );

			function onWindowResize() {
              camera.aspect = window.innerWidth / window.innerHeight;
				camera.updateProjectionMatrix();
				renderer.setSize( window.innerWidth, window.innerHeight );
			}

			function Init() {
				container = document.createElement( 'div' );
				document.body.appendChild( container );

				camera = new THREE.PerspectiveCamera( 90, window.innerWidth / window.innerHeight, 1, 2000 );

                setPlayerPosition();

				// scene
				scene = new THREE.Scene();

				scene.add( ambient );

				
				torch.position.set(camera.position.x,camera.position.y,camera.position.z);
				scene.add(torch);
				

				//var playerGroup = new Group();
				//playerGroup.add(camera);
				//playerGroup.add(light);
				
				var createTexture = function(message){
					var canvas = document.createElement('canvas');
					var context = canvas.getContext('2d');
					canvas.width = 400;
					canvas.height = 400;
					context.font = "3em Calibri";
					context.fillStyle = "white";
					context.fillText(message, 50, 50);

					var texture = new THREE.Texture(canvas);
					texture.needsUpdate = true;
					return texture;
				}
				
				var indice = new THREE.Mesh(new THREE.PlaneGeometry(5,3), new THREE.MeshPhongMaterial({map: createTexture("Fly straight up"), opacity: 0.9, transparent : true}));
				indice.position.set(-1.5,5,-21);
				indice.rotation.set(Math.PI / 2, -165 * Math.PI/180, 0);
				scene.add(indice);

				var indice2 = new THREE.Mesh(new THREE.PlaneGeometry(5,3), new THREE.MeshPhongMaterial({map: createTexture("a tip is hidden at this level"), opacity: 0.9, transparent : true}));
				indice2.position.set(-2.5,7,-10);
				indice2.rotation.set(Math.PI, 0, Math.PI);
				scene.add(indice2);

				var indice3 = new THREE.Mesh(new THREE.PlaneGeometry(5,3), new THREE.MeshPhongMaterial({map: createTexture("fly up through the rooftop"), opacity: 0.9, transparent : true}));
				indice3.position.set(5.9,7,-10);
				indice3.rotation.set(Math.PI/2, -Math.PI/2, 0);
				scene.add(indice3);

				var cube = new THREE.Mesh(new THREE.CubeGeometry(5,5,5),new THREE.MeshPhongMaterial( {ambient: 0x00aa00, color: 0x00aa00, specular: 0x555555, shininess: 50}))
				cube.position.set(6,7,-9);
				scene.add(cube);

				var geometry = new THREE.SphereGeometry( 1, 32, 32 );
				var sphereMaterial = new THREE.MeshPhongMaterial({ ambient: 0x000055, color: 0x0000ff, specular: 0x555555, shininess: 50});
				var sphere = new THREE.Mesh( geometry, sphereMaterial );
				sphere.position.set(-5,10.5,-21);
				scene.add( sphere );

				// texture

				var manager = new THREE.LoadingManager();
				manager.onProgress = function ( item, loaded, total ) {
					console.log( item, loaded, total );
				};
				
				var material = new THREE.MeshPhongMaterial({ ambient: 0xffffff, color: 0x000000, specular: 0x555555, shininess: 0});
				var texture = new THREE.Texture();

				var loader = new THREE.ImageLoader( manager );
				loader.load( '../TranseptSud/TranseptTexture4096.jpg', function ( image ) {
					texture.image = image;
					texture.needsUpdate = true;
				} );

				// Chargement du modèle de cathédrale
				var loader = new THREE.OBJLoader( manager );
				loader.load( '../TranseptSud/transeptSudBox.obj', function ( object ) {
					object.traverse( function ( child ) {
						if ( child instanceof THREE.Mesh ) {
							child.material = material;
							child.material.map = texture;
						}
					} );
					scene.add( object );
				} );

              renderer = new THREE.WebGLRenderer();
              renderer.setSize( window.innerWidth, window.innerHeight );
              container.appendChild( renderer.domElement );
			  window.addEventListener( 'resize', onWindowResize, false );
			  
			  document.addEventListener('keydown', KeyPressed, false);
			}

			function Afficher() {
                renderer.render(scene,camera);
			}

			function Animer() {
				//console.log(Math.sin(camera.rotation.x) + "," + Math.cos(camera.rotation.y) + "," + Math.sin(camera.rotation.z));
				console.log(camera.position.x + "," + camera.position.y + "," + camera.position.z);
				requestAnimationFrame(Animer);
				Afficher();
			}

           Init();
		   Animer();
		   
		   function KeyPressed(){
				switch(event.keyCode){
					case 81:
						camera.translateX(-moveSpeed);
						break;
					case 90:
						camera.translateZ(-moveSpeed);
						break;
					case 68:
						camera.translateX(moveSpeed);
						break;
					case 83:
						camera.translateZ(moveSpeed);
						break;
					case 37:
						camera.rotateY(rotateSpeed);	
						break;
					case 38:
						camera.rotateX(rotateSpeed);
						break;
					case 39:
						camera.rotateY(-rotateSpeed);
						break;
						case 40:
						camera.rotateX(-rotateSpeed);
						break;
				}
				
				if(camera.position.y > northBorder)
					camera.position.y = northBorder;
				if(camera.position.y < -northBorder)
					camera.position.y = -northBorder;

				if(camera.position.x > westBorder)
					camera.position.x = westBorder;
				if(camera.position.x < -westBorder)
					camera.position.x = -westBorder;

				if(camera.position.x > westBorder)
					camera.position.x = westBorder;
				if(camera.position.x < -westBorder)
					camera.position.x = -westBorder;

				if(camera.position.z > heightBorder)
					camera.position.z = heightBorder;
				if(camera.position.z < -heightBorder)
					camera.position.z = -heightBorder;


				if(camera.position.x > 4.3 && camera.position.x <= 4.5 && camera.position.y > 5.5 && camera.position.y < 10 && camera.position.z == 20.7){
					win();
				}

				torch.position.set(camera.position.x,camera.position.y,camera.position.z);
		   }

		   function setPlayerPosition(){
			   camera.position.set(0,-10,-20.5);

               camera.rotation.x= 90 * Math.PI/180;
		   }

		   function win(){
			ambient.color.setHex(0xffffff);
			camera.position.set(0,-10,-20.5);
			camera.rotation.x= 90 * Math.PI/180;
			camera.rotation.y = 0;
			camera.rotation.z = 0;
		   }

		</script>

	</body>
</html>
